// Main.c, main and only C file until we learn how to use
// the "almost a linker" CCS provides


// MultiGeiger main 8/2/09  EXP DMK

//@@@ not yet ready for case sensitivity in compiler

// includes/defines here

#include <18F6520.h>

#device ICD=TRUE // for microchip's ICD
#device ADC=10 // all ten bits available

#define T1_EXTERNAL_RTC 0x0f // missing from above header file (but in dox)
// Note, must keep TMR1 in 8 bit mode for bit-set reload to work.
// That technique prevents loss of low bits if it takes awhile to
// get to the interrupt to reload the timeout for the one second period


// now global pragmas, set up chip options and compiler
#fuses PUT,NOWDT,H4,CCP2E7,OSCSEN
#use fast_io (B) // used for rotary encoder and its pushbutton
#use fast_io (C) // we'll do our own tris'ing for serial etc
#use fast_io (G) // same as above
#use delay (clock=40M, oscillator=10M, restart_wdt) // we may someday enable watchdog timer
#use rs232 (UART2,BAUD=57600,PARITY=N,BITS=8,STREAM=AUX1) // no use, yet
#use rs232(UART1,BAUD=57600,PARITY=N,BITS=8)

// global variable declarations

int1 secflag = FALSE; // set this in tmr1 isr once a second
int8 seconds = 0;     // seconds since last reset -- in current minute
int8 minutes = 0;     // minutes of runtime
int16 hours = 0;      // hours
char tstamp[16] = "00000:00:00";      // timestamp 12 bytes + for sprintf()

unsigned int32 min_count = 0; // count accumulator for current minute 
unsigned int32 last_min_count = 0;  // previous full minute count

unsigned int16 TCh = 0;   // the ripples out of counter 0
unsigned int32 TCnew = 0; // total count new for main
unsigned int32 TCold = 0; // previous total count
unsigned int16 current_counts = 0; // per second at present


// phototube counts
unsigned int32  Cpt1 = 0;
unsigned int32  Cpt2 = 0;
unsigned int32  Cpt3 = 0;
unsigned int32  Cpt4 = 0;

//unsigned int16 ADRes;  // current a/d result
//unsigned int16 pwmtmp; // what we stuff into the pwm that runs
// the geiger tube power supply.  use/need all 10 bits.

// interrupt stuff, my "hungarian" precedes with I
// for rotary encoder
volatile int1 bREflag; // rotary encoder change flag
#define REPosMAX 127 // whatever the app wants for this
#define REPosMIN -127 // same as above
int1 IREDir;  // direction of change
int8 IRErd; // first pass through int sets this to portB RE bits
int8 IRErdZ;  // saves previous state of port read
signed int8 REPos; // current "position" of rot encoder, R/W

// for pb debounce machine
#define TIME3 64881 // 65536 - 32768/50 = 64881 for roughly 50 hz
#define BOUNCETICKS 2   // interacts with above
signed int8 Ipbctr = 0; // how long has pb been in some state
int1 IrdPB;       // needed to read port b PB bit
int1 IrdPBZ;      // previous state of above
volatile int1 bPBflag = FALSE; // flag to bckgnd that pb is pressed, debounced

/*
struct MSRMT {
unsigned int32 TotalCount;
unsigned int8 Seconds;
unsigned int8 Minutes;
unsigned int16 Hours;
unsigned int Flags; // may have some use
} Measures[8]; // seems like enough at the moment
*/

///////////////////////////////////////////////////////////////////////
#define LCD_COLS 16 // define this for line length of display
char blank_line[LCD_COLS+1] = {"                "};// lcd cols spaces
#include "LCD.c" // grab LCD driver, it's all simple subroutines
// including it here means no need for prototypes

// --------------------------------------------------------  
// control debug & datalog printf levels to stdout & macros
int8 debug = 0; // set to 0/1/2 disable/enable level 1/enable level 2
// use these macros like:
//   mDB1 printf("....",x);
#define mDB1 if(debug >= 1)printf
#define mDB2 if(debug >= 2)printf
//
int8 dlog = 1;  // set to 0/1 to disable/enable
#define mDlog if(dlog > 0)printf

// --------------------------------------------------------
// Background counts
struct bgv {
   long secs;
   int32 tg;
   int32 p1;
   int32 p2;
   int32 p3;
   int32 p4;
};

int bval_state = 0;
int bval_cur;

struct bgv bval; // current background count values 

//  EEPROM origin - may change as eeprom deteriorates
long eepOrg = 0;  
//  EEPROM layout
struct eepMap {
   struct bgv bv; // most recently saved set of background counts 
};
union {
   struct eepMap d;
   char b[sizeof(eepMap)];
} e, v;

// ----------------------------------------------------------------
// EEPROM access functions
//  saveEEP() saves current content of bval in EEPROM
//  readEEP() reads EEPROM into "v" then copies to bval
//
void saveEEP(){
    int n;
    mDlog("\r\nDLOG %s putEEbg ", tstamp);
    mDlog(" %Ld %Ld %Ld %Ld %Ld %Ld",
              bval.secs,bval.tg,bval.p1,bval.p2,bval.p3,bval.p4);
    e.d.bv = bval; // put bg vals in eepMap
    for(n=0; n<sizeof(eepMap);n++){        
        write_eeprom(eepOrg+n,e.b[n]);
        mDB1("\r\n\tsaveEEP: n:%d %02x",n,e.b[n]);        
    }
}
void readEEP(){
    int n;
    for(n=0; n<sizeof(eepMap);n++){
        v.b[n] = read_eeprom(eepOrg+n);
        mDB1("\r\n\treadEEP: n:%d %02x",n,v.b[n]);
    }
    bval = v.d.bv;
    mDlog("\r\nDLOG %s getEEbg ", tstamp);
    mDlog(" %Ld %Ld %Ld %Ld %Ld %Ld",
                bval.secs,bval.tg,bval.p1,bval.p2,bval.p3,bval.p4);
}

////////////////////////////////////////////////////////////////////////
void ZeroCount(void)
{
 set_timer0(0);
 TCh = 0; // high part outside of timer
 TCnew = TCold = 0;
 min_count = last_min_count = 0;
 set_timer0(0); // start fresh, no geigers
}
////////////////////////////////////////////////////////////////////////
void ZeroTime(void) // at start of new measurement, need to zero the time
{
 set_timer1(0);  // clear timer
 hours = minutes = seconds = 0; // clear variables 
}
////////////////////////////////////////////////////////////////////////
// Main initialization, hard and software

#fuses WDT,WDT128

void init ()
{  int rCause;
   char  msg[20];
   rCause = restart_cause();
   switch(rCause){
   case WDT_TIMEOUT:       
     strcpy(msg,"WDT timeout"); break;
   case MCLR_FROM_SLEEP:   
     strcpy(msg,"MCLR from sleep"); break;
   case MCLR_FROM_RUN:      
     strcpy(msg,"MCLR from run"); break;
   case NORMAL_POWER_UP:   
     strcpy(msg,"normal power up"); break;
   case BROWNOUT_RESTART:  
     strcpy(msg,"brown-out"); break;
   case WDT_FROM_SLEEP:    
     strcpy(msg,"wdt from sleep"); break;
   case RESET_INSTRUCTION: 
     strcpy(msg,"reset instruction"); break;
   default: 
     strcpy(msg,"other/unkown"); break;
   }
   mDlog("\r\nDLOG %s restart. Cause: %s (0x%02x)", tstamp, msg, rCause);
   
   setup_wdt(WDT_ON);

// hardware and memory initialization
// note, LCD sets trisE (and F) and we changed it this project
// to set tris E.7 as input for the CCP2 counter

 set_tris_g (0b00101); // for serial port 2, ccp3; ccp4 as output (rg3)
 set_tris_c (0b10011101); //serial port, 32 kHz osc, onboard led, ccp1 input
 set_tris_b (0b11110001); // user input via encoder and pushbutton 
 port_b_pullups(TRUE);    // keep other pins from toggling on noise?

// setup_timer_2(T2_DIV_BY_1,0xff,1); // use this below for PWM by default
// setup_CCP2(CCP_PWM); // use ccp2 on pin E7
// pwmtmp = 424; // roughly what it should be (start with LV, let loop boost it)
// set_PWM2_duty(pwmtmp); // pwm output to HV power supply input

 setup_timer_1(T1_EXTERNAL_RTC); // setup 32768 hz osc on T1, no prescale
 set_timer1(0x8000); // for one second period
 enable_interrupts(INT_TIMER1); // enables the timer1 interrupt   

 setup_timer_0(RTCC_EXT_L_TO_H | RTCC_DIV_1); // geiger tube input pin RA4
 enable_interrupts(INT_TIMER0); // give indication of overflow so we can count

///@@@ may have to use sync mode to make capture work right
 setup_timer_3(T3_EXTERNAL | T3_DIV_BY_1 | T3_CCP1_TO_5);// count 32 khz osc 
 // from timer1, and use for ccp capture mode on all ccps
 set_timer3(65535); // set immediate rollover for init
 enable_interrupts(INT_TIMER3); // we'll do PS reg, oneshots, etc here
 
 // we're just using this to generate an interrupt
 setup_ccp1(CCP_CAPTURE_RE); //interrupt on edge of phototube input RC2
 enable_interrupts(INT_CCP1);
 setup_ccp2(CCP_CAPTURE_RE); // interrupt on edge of phototube input RE7
 enable_interrupts(INT_CCP2);

 setup_ccp3(CCP_CAPTURE_RE); // interrupt on edge of phototube input RG0
 enable_interrupts(INT_CCP3);
 setup_ccp4(CCP_CAPTURE_RE); // interrupt on edge of phototube input RG3
 enable_interrupts(INT_CCP4);
 
 //////// let them rip
 enable_interrupts(GLOBAL); // start them now, see below
 
 LCD_init(); // use LCD driver for lcd init function, uses portE
 // and uses portF.7 for a second enable for large LCDs (2nd two lines)
 
// setup_adc(ADC_CLOCK_INTERNAL); // setup a/d
// setup_adc_ports(AN0 | VSS_VDD);// just the one -- all we need to regulate HV
// set_adc_channel(0); // and select it
 
 REPos = 0; // using LCD_init() as a delay to get this to start clean
 bREflag = FALSE; // so there's a T3 interrupt during the delay
 // beware the code that doesn't need to be there -- because it is already.
 
 ZeroCount(); // make geigers = 0
 ZeroTime(); // make runtime clock zero
 
 output_bit(PIN_F7, TRUE); // turn on power relay
 
 readEEP();  // pull EEPROM data structure

} // end of init()

////////////////////////////////////////////////////////////////////////
/// put the most frequently hit interrupts first to save cycles
#priority INT_CCP1,INT_CCP2,INT_CCP3,INT_CCP4,INT_TIMER3,INT_TIMER1,INT_TIMER0  
// ints checked in this order

////////////////////////////////////////////////////////////////////////
// ISRs
// A lot less fancy than the normal C-Lab project, but this is all that's
// needed, since we do lots of this in the hardware, at least all the time
// critical stuff.  The main reason for running at 40mhz in this is to
// get a fast pwm frequency at 10 bit rez.
//////////////////////////////////
// For whatever reason, we use tmr1 for the slow time of day clock
// and timer3 for the faster one for polling, both running on the same 32768hz
// crystal.  Since tmr3 is there, and hooked
// to the same input, we might as well use it.  It may save a cycle or two,
// depending on how efficient the dispatch is vs countng up to one
// second a few ms at a time.  We're not worrying about power use here.
//////////////////////////////////**********


////////////////////////////////////////////////////
#bit REa = IRErd.0 // bits for rotary encoder tests
#bit REb = IRErd.1 // these have to be outside the brackets

#int_timer3
void timer_3_interrupt() // nice long name, since I never call it!
{ // this counts the 32khz xtal like timer1 does, but we hit faster.
   set_timer3 (TIME3);  // defined above
 

// machine for pushbutton debounce "fiendshly clever"
//   IrdPB = (input_F() & 0x40) >> 6; // get port state at this instant
   IrdPB = (input_F() & 0x40) ? 1:0; // get port state at this instant

   if (IrdPB == IrdPBZ) // no change by button
      {
         if (IrdPB && Ipbctr > -BOUNCETICKS) Ipbctr--; // still no press?
         else if (Ipbctr < BOUNCETICKS+1) Ipbctr++; // note implies PB is low
         if (Ipbctr == BOUNCETICKS) bPBflag = TRUE;// here one bounceticks
      } else // button is bouncing, wait till something real happens
      {
         Ipbctr = 0; // start over
         IrdPBZ = IrdPB; // make the same after this
         bPBflag = FALSE; // just in case bkgnd didn't clear it
      }
// machine for rotary encoder, could be the shortest code ever
// basic code also works with int on change, if nothing else is using B

   IRErd = (input_B() & 0x30) >> 4; // easier on my head to shift bits down
   if (IRErd != IRErdz) // an actual change occurred
   {// if two bits changed, this might do wrong thing, never happens?
    // removed testing code for that, saved some bits
    IREDir = (REa ^ REb) ^ (IRErd ^ IRErdZ);  // xor of current state bit
    // then a change bit, sets direction.  Weird, but correct.
    // now, count the counter in the correct direction, if it won't overflow 
    if (IREDIR)
    {
     if (REPos < REPosMAX) REPos++;
    }
    else 
    {
     if(REPos > REPosMIN) REPos--;
    }
    IRErdZ = IRErd; // make the same again, for next change test
    bREflag=TRUE; // set a flag for background
   }
}
//////////////////////////////////**********
#int_timer1 // flag each passing second
void timer_1_interrupt()
{ // important to reload timer in a timely way
#byte TMR1H = 0xfcf  // tested if these work in access bank, NOT!
 bit_set(TMR1H,7);   // makes a bsf, but no TMR1L access, and no effect
 secflag = TRUE;     // set flag for background, let it do the calx for HMS,
 //can then read them without ever having a carry error during capture
}

//////////////////////////////////**********
#int_timer0 // this one counts the geigers
void timer_0_interrupt()
{ // geigers have overflowed!
 TCh++; // ripple up into more bits for long or fast counts
} // If we're hitting this very fast -- run like hell!
  // (and bring me with you ;~)  Counter tube maxes out around 20khz or so
  
//================= Exponential Moving Average funcs =============
//
// doEmaS(newVal, prevEma, Smooth)
//   same as doEma() below, except 3rd arg is a smoothing value calculated
//   by the caller: smooth = 2.0/(1.0 + points)
//
// Rationale: avoid lots of FP calcs by having caller(s) 
// precalculate a smoothing value (once), and pass as an arg.
//
float doEmaS(float newVal, float prevEma, float Smooth){
    float ema;
    ema = (Smooth * (newVal - prevEma)) + prevEma;
    return(ema);
}

// -----------------------------
//
// doEma(newData, prevEma, points)
//  calculate Exp Moving Average (ema)
//  where: newData - current datapoint value
//         prevEma - previous ema value 
//         points - number of dataPoints in moving average
//
float doEma(float newVal, float prevEma, int points){
    float smooth, ema;
    smooth = 2.0/(1.0 + points);
    ema = (smooth * (newVal - prevEma)) + prevEma;
    return(ema);
}

//========================================
//
//lcd_put(line, msg)
//   where: line = 0 or 1 (the lcd line)
//          msg  = a ptr to the message (max len = LCD_COLS, auto-truncate)
//                   )
#include <string.h>
void lcd_put(int8 line, char *msg){
     char lcd_buf[LCD_COLS+2];
     int mlen;
     int8 ltm;
     strcpy(lcd_buf, blank_line);
     mlen = strlen(msg);
     ltm = mlen > LCD_COLS ? LCD_COLS : mlen;
     memcpy(lcd_buf, msg, ltm);
     LCDOutXY(0,line,lcd_buf);
}

//======================================================
//  More Globals (DMK's list)

char lcd_line[LCD_COLS+2 + 50]; // oversized to allow printf overruns
// Misc state variables
char UI_state = 0;
char SM_state = 0;

#define LCD_DEFAULT 0
#define LCD_SCROLL 1
#define LCD_SCROLL_BG 2

char LCD_mode = 0;
char savedLCDmode = LCD_DEFAULT;

char bgSuffix[6] = {0};

#define TGeMApOINTS 10
float tgEmaSec = 0;
float tgSmooth = 0;

// countdown stuff
signed int16 intvl_left = 0;  // countdown, remaining seconds
signed int16 intvl_set = 0;  // interval set, seconds
signed int32 tg=0, p1=0, p2=0, p3=0, p4=0; // current count during interval
float ptg=0, pp1=0, pp2=0, pp3=0, pp4=0; // count during previous interval
signed int32 stg=0, sp1=0, sp2=0, sp3=0, sp4=0; // saved counts, for recalc BGsubt
char iSuffix[5] = "";

int1 setBGflag = FALSE; // when set, countdown totals will be set as background counts
int1 BGsubt = FALSE;    // BG subtraction when TRUE, no subtraction when FALSE
signed int32 bg_period = 0, bgp_countdown = 0; // seconds for background count period
float bg_tg = 0, bg_p1 = 0, bg_p2 = 0, bg_p3 = 0, bg_p4 = 0; // Background counts
unsigned int16 wThresh[5] = {0,0,0,0,0};


// Photo tube counters.  later we could add prescaling based on UI or
// other inputs, so we won't croak trying to catch all these one at a 
// time.  Tradeoff is we can't read the prescaler, so lose precision.

#INT_CCP1 // count a phototube
void cpt1_interrupt ()
{
 Cpt1++; // record the count
 if(wThresh[1] < 65535) wThresh[1]++;
}
#INT_CCP2 // count a phototube
void cpt2_interrupt ()
{
 Cpt2++; // record the count
 if(wThresh[2] < 65535) wThresh[2]++;

}
#INT_CCP3 // count a phototube
void cpt3_interrupt ()
{
 Cpt3++; // record the count
 if(wThresh[3] < 65535) wThresh[3]++;
}
#INT_CCP4 // count a phototube
void cpt4_interrupt ()
{
 Cpt4++; // record the count
 if(wThresh[4] < 65535) wThresh[4]++;
}

//===============================================================
// lcd_display() - display default (i.e. non-UI) lines to lcd
//   LCD_mode: 0 - default display
//             1 - scrolled display of current countdowns
//             2 - scrolled display of current background settings
//
static int1 first_int = TRUE;
void lcd_display(void){
    static int pline = 0;
    switch(LCD_mode){
    case LCD_DEFAULT: // default
        //sprintf(lcd_line,"%s%Lu%s%02u%s%02u","Tm:",hours,":",minutes,":",seconds);
        sprintf(lcd_line,"Tm:%s",tstamp);       
        lcd_put(0,lcd_line);
        sprintf(lcd_line,"%s%Lu%s%Lu%s%Lu","S:",current_counts," M:",last_min_count,
           " P:",Cpt1);
        lcd_put(1,lcd_line);
        break;
    case LCD_SCROLL: // test interval countdowns
        sprintf(lcd_line,"T:%04Ld/%04Ld", intvl_set, intvl_left);
        lcd_put(0,lcd_line);
       
        // scrolls line 2 thru countdown totals
        #define PMIN 0
        #define PMAX 4
        if (bREflag){
            bREflag=FALSE;
            if (IREDIR){ // +
              if (pline < PMAX )pline++;
            } else { // -
              if (pline > PMIN)pline--;
            }
            //mDB2("\r\n\tpline set to %d", pline);
        }
        if (first_int){
            ptg = tg;
            pp1 = p1;
            pp2 = p2;
            pp3 = p3;
            pp4 = p4;
            strcpy(iSuffix,"cur");
        }    
        switch(pline){
        case 0:
            //sprintf(lcd_line,"G:%Ld%c a:%.2f",ptg, iSuffix, tgEmaSec);
            sprintf(lcd_line,"G:%.2f%s",ptg, iSuffix);
            break;
        case 1:
            sprintf(lcd_line,"P1:%.2f%s",pp1,iSuffix);
            break;
        case 2:
            sprintf(lcd_line,"P2:%.2f%s",pp2,iSuffix);
            break;
        case 3:
            sprintf(lcd_line,"P3:%.2f%s",pp3,iSuffix);
            break;
        case 4:
            sprintf(lcd_line,"P4:%.2f%s",pp4,iSuffix);
            break;
        default:
            break;
        }       
        lcd_put(1,lcd_line);
        break;
    case LCD_SCROLL_BG: // background settings
        sprintf(lcd_line,"BGpd:%05Ld/%05Ld", bg_period, bgp_countdown);
        lcd_put(0,lcd_line);
        if ( bg_period == 0 ) { 
           // use values from EEPROM [read by init(), if previously save
           if ( v.b[0] != 0xff ) { // not 0xff if set of BG values saved
               bg_period = v.d.bv.secs;
               bg_tg = v.d.bv.tg;
               bg_p1 = v.d.bv.p1;
               bg_p2 = v.d.bv.p2;
               bg_p3 = v.d.bv.p3;
               bg_p4 = v.d.bv.p4;
               strcpy(bgSuffix,"(svd)");
           }
        }
        // scrolls line 2 thru 5 bg settings
        #define BG_PMIN 0
        #define BG_PMAX 4
        if (bREflag){
            bREflag=FALSE;
            if (IREDIR){ // +
              if (pline < BG_PMAX )pline++;
            } else { // -
              if (pline > BG_PMIN)pline--;
            }
            //mDB2("\r\n\tpline set to %d", pline);
        }    
        switch(pline){
        case 0:
            sprintf(lcd_line,"G:%.2f%s",bg_tg, bgSuffix);
            break;
        case 1:
            sprintf(lcd_line,"P1:%.2f%s",bg_p1, bgSuffix);
            break;
        case 2:
            sprintf(lcd_line,"P2:%.2f%s",bg_p2, bgSuffix);
            break;
        case 3:
            sprintf(lcd_line,"P3:%.2f%s",bg_p3, bgSuffix);
            break;
        case 4:
            sprintf(lcd_line,"P4:%Ld%s",bg_p4, bgSuffix);
            break;
        default:
            break;
        }       
        lcd_put(1,lcd_line);
        break;
    default:
        break;
    }
    return;
}    
//======================= do_menu ( menu-number ) =======
// First level menus
//
#define MENU_MIN 0
#define MENU_MAX 7
const char UI_menu[MENU_MAX+1][*] = {
  "Exit", 
  "Set Test Intrvl", 
  "LCD Toggle",
  "doTest",
  "4-dynamic",
  "Collect BG Cts",
  "Show BG counts",
  "Relay toggle"
};
  
void do_menu( signed char menu ){
   mDB1("do_menu: menu:%d\n", menu);
   if ( menu < MENU_MIN ) menu = MENU_MIN;
   if ( menu > MENU_MAX ) menu = MENU_MAX;
   // specials for dynamic 1st level menus
   switch(menu) {
   case 4: // 4-dynamic {Start|Stop} BG Subtraction menu item
       if(BGsubt){
           sprintf(lcd_line, "Stop BG subtr");
       } else {
           sprintf(lcd_line, "Start BG subtr");
       }
       break;
   default:      
       sprintf(lcd_line, "%s", UI_menu[menu]);
       break;
   }
   lcd_put(0, lcd_line);   
   sprintf(lcd_line, "PB to select"); // default 2nd line   
   lcd_put(1, lcd_line);
   REPos = menu;  // limit to range of menus
}

// ---------------------------------------------------------------
// LCD_toggle()
//     toggle LCD display mode, no submenu selections
//     LCD_mode used by lcd_put() to determine layout
//
int LCD_toggle(void){
   switch(LCD_mode) {
   case LCD_DEFAULT:
       LCD_mode = LCD_SCROLL;
       break;
   case LCD_SCROLL:
       LCD_mode = LCD_DEFAULT;
       break;
   default:
       LCD_mode = LCD_DEFAULT;
       break;
   }
   return(0);
}

//===============================================================
// Submenu routines - general rules
//  input: various: use globals
//  output: various: set globals
//  return: -1 - task incomplete (keep returning here for a selection)
//           0 - when task is complete
//          +n - to return a "selection/completion" value (signed int) to engage()


// ---------------------------------------------------------------
// int setRelay(tf)
//   input: tf - TRUE  turn on power relay
//               FALSE  turn power off
//   output rc = 0
//
int1 relayState = TRUE; // on
int setRelay(int tf){
        mDB1("\r\n\tsetRelay entry");
    if ( tf == 0 ){ 
        mDB1("\r\n\trelay off");
        relayState = FALSE;
        // set PIN_F7 low (relay OFF)
        output_bit(PIN_F7, FALSE);
    } else {
        mDB1("\r\n\trelay on");
        // set PIN_F7 high (relay ON)
        output_bit(PIN_F7, TRUE);
        relayState =  TRUE;
    }
    return(0);
}

// ----------------------------------------------------------
// AlarmOn - SOUND AUDIBLE ALARM 
//  input: alarm on for x seconds
//         
//  use 190ms delay for tone loop
#define TMAX 10000
#define aDelay 200
int alarmOn(void){
    long n;
    long del = aDelay;
    // mDB1("\r\n\talarmOn entry");
    mDlog("\r\nDLOG %s Alarm ", tstamp);
    for (n = 0; n < TMAX; n++){
       output_toggle(PIN_G3); // make some noise
       delay_us(del);
    }
    return(0);
}

//  emergencyKill() - sound alarm and turn off power relay
//
void emergencyKill(void){    
    if (relayState == TRUE){
        setRelay(FALSE);
        mDlog("\r\nDLOG %s emKill ", tstamp);      
        alarmOn();
    }
}

// reset p1-p4 counters for background/test interval
void reset_ctrs(){    
    Cpt1 = Cpt2 = Cpt3 = Cpt4 = 0;  // Reset photo counters
}

// ------------------------------------------------------------
// set_interval(iType)  Sets a countdown value (seconds)
// input: RE scrolls thru mintvl values, 
//        PB selects
// output: selected interval value returned via global "setVal"
//         return value: 0 - on PB selection
//                       1 - no selection/PB
//
#define MAX_INT 16
const int16 mintvl[MAX_INT] = {-1,0,1,2,5,10,20,50,100,200,500,
                         1000,2000,3000,4000,30000};

signed int16 setVal = 0; // current value (menu[REPos])
signed int8 prevBGsub = 0, prevTIsub = 0; // to save selected BG and TestIntvl menus subs
const int8 mas = sizeof(mintvl)/sizeof(int16) - 1;

signed int16 set_interval(void){
   int8 s = 0;
   // RE input processed here
   if (bREflag){
      bREflag=FALSE;
      //mDB1("\r\n\tRE changed:%d mas:%d", REPos, mas);
      if (REPos >= 0 && REPos < mas ){
          s = REPos;
      } else { // set REPos to min/max position
          if (REPos < 0){
              REPos = s = 0; 
          } else {
              REPos = s = mas;        
          }
      }
      //mDB1("\r\n\ts:%d mintvl[s]:%Ld", s, mintvl[s]);
      setVal = mintvl[s];
   }
   // output the LCD menu
   switch (REPos) {
   case 0:
      sprintf(lcd_line,"BACK");
      break;
   case 1:
      sprintf(lcd_line,"Cancel");
      break;
   default:
      sprintf(lcd_line,"%Ld seconds", setVal);
      break;
   }
   lcd_put(0,lcd_line);
   sprintf(lcd_line,"PB to select");
   lcd_put(1,lcd_line);
   
   if(bPBflag){ // 2nd press selects interval
      mDB1("\r\n\t2nd PB press = setVal:%Ld REPos:%d", setVal, REPos);
      bPBflag=FALSE; // trigger this (whatever) only once

      return(0);
   }
   return(-1);
}

// debug display for bg counts

void showBGvect(struct bgv bv){
   mDB1("\r\nbval_cur:%d bval_state:%d ", bval_cur,bval_state);
   mDB1("%Ld - ", bv.secs);
   mDB1("%Ld ", bv.tg);
   mDB1("%Ld ", bv.p1);
   mDB1("%Ld ", bv.p2);
   mDB1("%Ld ", bv.p3);
   mDB1("%Ld\r\n", bv.p4);
}

// --------------------------------------------------
//  setBGvals() - This is an abbreviated version that saves only one bg 
//     period & counts vector (struct) in EEPROM (as a struct bgv).  
//
//     The original setBGvals, which populated an array of bgv structs for
//     various periods is saved in snips.c.
//
//     This version does, however, operate with the same states (1 is NOP), and
//     should be called repeatedly while its rc == 1.
//
//  rc = -1 error (undefined)
//        0 done
//        1 work in progress, y'all come back...
//
// bval_state - (global) state of the bval array:
//    0 - not ready
//    1 - (NOP)
//    2 - write bgv to EEPROM
//    3 - ready, written to EEPROM
//
signed int setBGvals(int32 secs, float tg, float p1, float p2, float p3, float p4){
   int rc;   
   //mDB1("\r\n\tsetBGvals args secs:%Ld, tg:%Ld\r\n", secs, tg);
   switch(bval_state) {
   case 0:   // save in progress
      mDlog("\r\nDLOG %s bgSave ", tstamp);
      mDlog("%Ld %f %f %f %f %f",secs,tg,p1,p2,p3,p4);
      bval.secs = secs;
      bval.tg = tg;
      bval.p1 = p1;
      bval.p2 = p2;
      bval.p3 = p3;
      bval.p4 = p4;

      bval_cur = 0;
      bval_state = 2; // skip state 1
      rc = 1;
      break;
   case 1: // should never happen, but go to state 2 if it does
      bval_state = 2; // save complete, 
      rc = 1;  
      break;
   case 2: 
      // write to EEPROM... 
      saveEEP();
      mDB1("\r\n\tbval written to EEPROM");
      bval_state = 3;  // EEPROM array written, "ready"
      setBGflag = FALSE; // BG is done
      rc = 0;
      break;
   default:
      rc = 0;
      break;
   }
   return(rc);
}

//--------------------------------------------------------------
// scrollBGmodes() - scroll BG settings in lcs_display()
//
int scrollBGcounts(){
   //if (bval.secs == 0) return(0); // nothing useful to display
   lcd_display(); // handles the RE input for scrolling
   if(bPBflag){ // Exit (on PB)?
      bPBflag=FALSE; 
      return(0); // yes...
   }
   return(-1); // stay in this mode
}

// doBGsubt() - prepare interval display counts with/without 
//         nomalized BG counts, and convert to counts/minute
//   INPUT: BGsubst
//          current BG duration & counts (in bval struct)
//          saved test interval (intvl_set, )and counts (sxx)
//   OUTPUT: ptg,pp1,pp2,pp3,pp4 (the display values)
//
void doBGsubt(void){
    float bgFactor;
    float pmFactor;
    
    pmFactor = 60.0/intvl_set;
    
    if (bval.secs > 0 && BGsubt) { 
       // adjust bg counts to test interval, and subtract from raw counts
       // then adj to counts/minute
       bgFactor = (float)intvl_set/bval.secs;       
       ptg = pmFactor*(stg - bgFactor*bval.tg);
       pp1 = pmFactor*(sp1 - bgFactor*bval.p1);
       pp2 = pmFactor*(sp2 - bgFactor*bval.p2);
       pp3 = pmFactor*(sp3 - bgFactor*bval.p3);
       pp4 = pmFactor*(sp4 - bgFactor*bval.p4);
       strcpy(iSuffix, "/min*");
    } else { // adjust raw counts to counts/minute
       ptg = pmFactor * stg;
       pp1 = pmFactor * sp1;
       pp2 = pmFactor * sp2;
       pp3 = pmFactor * sp3;
       pp4 = pmFactor * sp4;
       strcpy(iSuffix, "/min");
    }
    return;
}

// ---------------------------------------------------------------------
//  setBGsubtract(int1 onOff) - enables/disables subtraction of BG counts from
//  displayed test interval counts.
// INPUT: onOff - TRUE enable subtraction
//                FALSE disable subtraction
// OUTPUT: sets BGsubt to onOff, when test interval set
//
int setBGsubtract(int1 onOff){
    
    if (intvl_set != 0){
        BGsubt = onOff;
        mDB1("\r\n\tBGsubt:%d", BGsubt);
        doBGsubt(); // recalc BG counts, as necessary
    }
    return(BGsubt);
}


// --------------------------------------------------------------
//  general test selection for new UI functionality
//
int doTest(void){
    int rc;
    static int1 toggle = TRUE;
    mDB1("doTest entry");
    // call the test function...
    mDB1("\r\n\ttoggle:%d", toggle);
    rc = setBGsubtract(toggle);
    toggle = toggle? FALSE : TRUE;
    mDB1("\r\n\ttoggle:%d", toggle);
    return(rc);
}

////////////////////////////////// submenu dispatcher ///////////////
// engage() input: SM_state (global variable)
//    dispatch menu-specific (submenu) functionality
//         (which handle RE/PB hits.
//    return: 0 - when submenu selection (if any) is complete
//            non-0 - when more to do 
//                 submenu may return -1 when no selection has been made
//                                    +n more to do after selection 
//

signed int engage(){
   signed int rc = 0;
   int n;

   switch(SM_state){
      case 0:
         rc = 0;
         break;
      case 1: // select time interval for test (duration)
         // NOTE: needs to be mutually exclusive of BG collection, so
         // if BG collection in progress, no test interval will be set
         if(setBGflag == FALSE){ // disables setting test intervals during BG collection         
             rc = set_interval(); // set_interval() handles RE/PB
         } else {
             rc = 0;
             break;
         }
       
         if (rc == 0) { // selection made...
           if ( setVal < 0) { // "BACK" selected, do nothing
              rc = 0;
           } else {
              // Reset duration counts & 1st time flag
              tg = p1 = p2 = p3 = p4 = 0;
              reset_ctrs();           
              first_int = TRUE;
              intvl_set = intvl_left = setVal;
              prevTIsub = REPos;
              mDB1("\r\n\tDB1 prevTIsub set to %d", REPos);
              // NOTE - when selected interval is 0, alarms become inactive
              setRelay(TRUE);  // reset power relay (to ON)
              LCD_mode = LCD_SCROLL;  // set LCD display to show interval countdown
              for ( n = 0; n< 5; n++ ){         
                 wThresh[n] = 0;                
              }
           }
         }
         break;
      case 2: // Toggle LCD_mode
         rc = LCD_toggle();          
         break;
      case 3: //Select Test
         rc = doTest();
         break;
      case 4:
         if (BGsubt)             
             setBGsubtract(FALSE); // it's on, turn it off
         else
             setBGsubtract(TRUE);  // it's off, turn it on
         rc = 0;
         break;
      case 5:
         // Establish, restart, or cancel (select interval=0)
         // Background Count collection
         if(intvl_left) {  // cancel remaining test interval, if running
             intvl_set = intvl_left = 0;
         }
         setBGflag = TRUE; 
         rc = set_interval(); // Set bg count period
        
         if (rc == 0) { // interval selection made
           if ( setVal < 0) { // "BACK" selected, do nothing
              rc = 0;
           } else {
             bgp_countdown = bg_period = setVal;
             prevBGsub = REPos;
             mDB1("\r\n\tDB1 prevBGsub set to %d", REPos);
             if (bg_period == 0) { // cancel collection, restore display mode            
                setBGflag = FALSE; 
                bgSuffix[0] = NULL;
                LCD_mode = savedLCDmode;
                mDB1("\r\nDLOG %s BG collection canceled", tstamp);
             } else {  //  initiate BG count collection                
                bg_tg = bg_p1 = bg_p2 = bg_p3 = bg_p4 = 0;                
                reset_ctrs(); // reset primary counters
                strcpy(bgSuffix,"(cur)");
                // change display to show bg countdown, revert to prev mode
                // when countdown complete (
                savedLCDmode = LCD_mode;
                LCD_mode = LCD_SCROLL_BG;                
             }
           }
         }
         break;
      case 6: // Scroll current BG counts, PB exits         
         LCD_mode = LCD_SCROLL_BG;
         rc = scrollBGcounts();
         if ( rc == 0 ){
            LCD_mode = LCD_default;            
         }
         break;
      case 7: // Relay ON/OFF toggle
         if (relayState)             
             setRelay(FALSE); // it's on, turn it off
         else
             setRelay(TRUE);  // it's off, turn it on
         rc = 0;
         break;
      default:
         rc = 0;
         break;
   }
   return(rc);
}


//======================= User Interface State machine ===========
void UI_states(){
   int rc;
   switch(UI_state){
   case 0 :
      if (bPBflag){ // look for 1st press (enter UI)
         UI_state = 1;
         mDB1("\r\n 1st PB press");
         bPBflag=FALSE; // trigger this (whatever) only once
         REPos = 0;     // for next RE use
      } 
      lcd_display();
      break;
   case 1 : // to select 1st level menu
      do_menu(REPos);      
      UI_state = 2;
      break;
   case 2: // look for RE/PB input to scroll/select in 2nd level menu
      if (bREflag){
         bREflag=FALSE;      
         mDB1("\r\n\tRE changed:\t%x", REPos);
         do_menu(REPos);
      }
      if (bPBflag){  // look for 2nd press
         // got 2nd press, engage new settings         
         mDB1("\r\n 2nd PB press, REPos:%d", REPos);
         bPBflag=FALSE; // trigger this (whatever) only once
         SM_state=REPos;
         // special case for menu selections that call set_interval()
         switch (SM_state) {
         case 1: // set Test Interval subscript start
             REPos = prevTIsub;
             setVal = mintvl[REPos];
             mDB1("\r\n\tDB1 REPos set to prevTIsub%d setVal:%Ld", REPos, setVal);
             break;
         case 5: // set BG collection interval subscript start
             REPos = prevBGsub;
             setVal = mintvl[REPos];
             mDB1("\r\n\tDB1 REPos set to prevBGsub%d setVal:%Ld", REPos, setVal);             
             break;
         default:
             break;
         }
         rc = engage(); // do it...
         if (rc == 0 )
             UI_state = SM_state = 0; // return to state 0
         else
             UI_state = 3; // enter state 3 for submenu selections
         lcd_display();
      }
      break;
   case 3: // divert to 2nd level sub-menu
      rc = engage();
      if (rc == 0 ){
          UI_state = SM_state = 0; // return to state 0
      }
      break;
   default:
      UI_state = SM_state = 0;
      break;
   }   
}

//***************************************************************************//
void main()
{ 
 int n; // general counter
 
 // onetime stuff, then fall into forever loop
 //char lcd_buf[LCD_COLS+2]; // more than needed?  Remember trailing null! 
 
 init();  // do init of various hardware stuff and variables
 
 //*****************************
 for (;;) // main forever loop  "#define EVER ;;" for more fun
 {
  if (secflag)
  {
     secflag = FALSE; // clear the foreground flag
     seconds++;
     if (seconds >= 60) // once a minute, belt and suspenders if test
     {
      seconds = 0;
      last_min_count = min_count; // keep an old one around always valid for display
      min_count = 0;     // reset for second by second accumulation
      minutes++;
      if (minutes >= 60) // once an hour 
      {
       hours++;
       minutes = 0;
      }
     } // if a minute
      sprintf(tstamp,"%Lu:%02u:%02u",hours,minutes,seconds); // set a
 
// still every second    

     if(tgSmooth == 0) tgSmooth = 2.0/(1.0 + TGeMApOINTS);
     tgEmaSec = doEmaS(current_counts, tgEmaSec, tgSmooth);
     
     TCold = TCnew; // save last value
     // construct new value then know counts to print  
     disable_interrupts(INT_TIMER0);
     TCnew = make32(TCh,get_timer0()); //total count from timer and overflows
     enable_interrupts(INT_TIMER0);
     
     current_counts = TCnew - TCold; // counts for this second
     min_count += current_counts; // keep track of cpm
     
     // update geiger counts only once/sec
     if(intvl_left > 0) tg += current_counts;     
     if(wThresh[0]+current_counts < 65535) wThresh[0] += current_counts;
            
     // The "interval" countdowns
     intvl_left && intvl_left--;
     if (intvl_set > 0 && intvl_left == 0 ){
        //Interval expired, save counts, reset & restart
        // the pxx vars are the displayed set, the sxx vars are saved for
        // (re)calculation when BGsubt changes
        stg = ptg = tg;
        sp1 = pp1 = p1;
        sp2 = pp2 = p2;
        sp3 = pp3 = p3;
        sp4 = pp4 = p4;
        
        doBGsubt(); // subtract BG counts, if necessary, adj for per-minute 
        
        mDlog("\r\nDLOG,%s,intExp,", tstamp);
        mDlog("%Ld,%.0f,%.0f,%.0f,%.0f,%.0f,",intvl_set,ptg,pp1,pp2,pp3,pp4); // display vals (per-minute)
        //mDlog("%Ld,%Ld,%Ld,%Ld,%Ld,%Ld",intvl_set,tg,p1,p2,p3,p4); // per-second   
        
        tg = p1 = p2 = p3 = p4 = 0;
        reset_ctrs();
        if (intvl_set > 1 ) first_int = FALSE; // tell lcd_default
        intvl_left = intvl_set; // Restart interval
     }
     
     // The "set background" countdown
     if (setBGflag && bgp_countdown > 0) {
        bg_tg += current_counts;
        if (--bgp_countdown <= 0){ 
           // BG period expired
           bval_state = 0; // reset setBGvals() state machine
           setBGflag = FALSE;
           // restore saved display mode
           LCD_mode = savedLCDmode;
           // save (integral) bg counts before adjusting values to per-minute
           setBGvals(bg_period,bg_tg,bg_p1,bg_p2,bg_p3,bg_p4);
           // recalc display counts to simple mean (avg count/minute)
           bg_tg = 60.0 * bg_tg/bg_period; 
           bg_p1 = 60.0 * bg_p1/bg_period;
           bg_p2 = 60.0 * bg_p2/bg_period;
           bg_p3 = 60.0 * bg_p3/bg_period;
           bg_p4 = 60.0 * bg_p4/bg_period;
           strcpy(bgSuffix, "/min");
        } 
     }
     
     // Run setBVvals() as quasi-background task for states 1 & 2
     if ( bval_state >= 1 && bval_state < 3) {
         setBGvals(0,0,0,0,0,0);         
     }

   // split up printf's for sanity, this is all debug stuff for now
     mDB1("\r\n%s%Lu","CpS:",current_counts); // testing
   //mDB1 ("%s%Lu%s%Lu"," A/D:",ADRes," PWM:",pwmtmp);
     mDB1("\tPB:%x flag:%d U:%d S:%d",
         (input_B() & 0x30) >> 4,bPBflag,UI_state, SM_state);
     mDB1("\tCpM:%Lu",last_min_count);
     mDB1("\tTot:%Lu",TCnew);
     mDB1("\tPos:%d  Dir:%u",REPos,IREDIR);
     mDB1("\tTime: %s ",tstamp);
     mDB1("P1:%LuP2:%LuP3:%LuP4:%Lu",Cpt1,Cpt2,Cpt3,Cpt4);

//     fprintf(AUX1,"%s%Lu%s%02u%s%02u","\r\nTime: ",hours,":",minutes,":",seconds);
// this causes further printf's to be directed to AUX1

// more testing/debug
//    LCDCursorXY(14,1,0);
    
     output_toggle(PIN_C5); // show we are alive
     
 }    // end if seconds flag /***********************************/
     
     // update other interval accumulators 
     if(intvl_left) p1 = Cpt1; // bump countdown value
     if(bgp_countdown) bg_p1 = Cpt1;

     if(intvl_left) p2 = Cpt2; // bump countdown value
     if(bgp_countdown) bg_p2 =Cpt2;
     if(intvl_left) p3 = Cpt3; // bump countdown value
     if(bgp_countdown) bg_p3 = Cpt3;
     if(intvl_left) p4 = Cpt4; // bump countdown value
     if(bgp_countdown) bg_p4 = Cpt4;
     
            
     if ( intvl_left ) {
         // While Test Interval Set, check for dangerous count levels
         //   DANGER arbitrarily set to 2000
         //
         #define DANGER 2000
         for ( n = 0; n< 5; n++ ){         
            //mDB1("\r\nwThresh[%d]:%Ld",n,wThresh[n]);
            if ( wThresh[n] > 0 ){
                if ( --wThresh[n] > DANGER ) {
                    emergencyKill();             
                }
            }
         }
     }
   
     UI_states();  //hook to the LCD menus & output
     
     restart_wdt();
     
 } // end forever loop   
}// main   
//*****************************************************************************

